# CNOE Stacks

This repository contains building blocks and examples to help you build your own Internal Developer Platform.

## Getting Started

### Install idpbuilder

To get started, you need to install [`idpbuilder`](https://github.com/cnoe-io/idpbuilder).
See [the instructions](https://github.com/cnoe-io/idpbuilder?tab=readme-ov-file#getting-started) in the idpbuilder repository for details.

### Using this repository

- **[CNOE Reference Implementation](./ref-implementation)**. Create a local CNOE environment in minutes. 
- **[Basic Examples](./basic)**. Do you want to know how to use idpbuilder with basic examples?
- **[Local Backup](./local-backup)**. How do I make sure my work is backed up?
- **[Localstack](./localstack-integration)**. Use [LocalStack](https://github.com/localstack/localstack) to test out cloud integrations.
- **[Terraform Integrations](./terraform-integrations)**. Integrating Terraform with Reference Implementation.
- **[Dapr Integration](./dapr-integrations)**. Integrating the Dapr APIs for Building Secure and Reliable Microservices .
